#include <windows.h>

#include <filter.h>



static const LPCSTR DIALOG_CLASSNAME = "ExtendedFilterClass";

HWND g_hwnd_exedit = NULL;
HWND g_hwnd_dialog = NULL;


void AddExStyle(HWND hwnd, DWORD exstyle)
{
	SetWindowLong(hwnd, GWL_EXSTYLE, GetWindowLong(hwnd, GWL_EXSTYLE) | exstyle);
}

void ClearExStyle(HWND hwnd, DWORD exstyle)
{
	SetWindowLong(hwnd, GWL_EXSTYLE, GetWindowLong(hwnd, GWL_EXSTYLE) & ~exstyle);
}

// IuWFNgݒ_CAO擾
HWND GetObjectDialog(void)
{
	struct local {
		static BOOL CALLBACK proc(HWND hwnd, LPARAM lp)
		{
			if(GetWindow(hwnd, GW_OWNER) != g_hwnd_exedit) return TRUE;

			char buf[256];
			GetClassName(hwnd, buf, sizeof(buf));
			if(strcmp(buf, DIALOG_CLASSNAME)) return TRUE;
			*(HWND*)lp = hwnd;
			return FALSE;
		}
	};

	HWND hwnd = NULL;
	EnumWindows(local::proc, (LPARAM)&hwnd);
	return hwnd;
}

// 
BOOL func_init(FILTER *fp)
{
	for(int i = 0; FILTER *exedit = (FILTER*)fp->exfunc->get_filterp(i); i++) {
		if(strcmp(exedit->name, "gҏW")) continue;

		g_hwnd_exedit = exedit->hwnd;
		break;
	}

	if(!g_hwnd_exedit) return FALSE;

	AddExStyle(g_hwnd_exedit, WS_EX_LAYERED);

	fp->exfunc->add_menu_item(fp, "}EX̔wiʒmON/OFF", fp->hwnd, 1, 0, 0);

	return TRUE;
}



// XV̏
BOOL func_update(FILTER *fp, int status)
{
	if(status == FILTER_UPDATE_STATUS_CHECK+0 || status == FILTER_UPDATE_STATUS_ALL) {
		if(fp->check[0]) {
			AddExStyle(g_hwnd_exedit, WS_EX_TRANSPARENT);
		} else {
			ClearExStyle(g_hwnd_exedit, WS_EX_TRANSPARENT);
		}
	}
	if(status == FILTER_UPDATE_STATUS_TRACK+0 || status == FILTER_UPDATE_STATUS_ALL) {
		SetLayeredWindowAttributes(g_hwnd_exedit, 0, fp->track[0], LWA_ALPHA);
	}

	return TRUE;
}



// EBhEbZ[W̏
BOOL func_WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp, void *editp, FILTER *fp)
{
	switch(msg) {
		case WM_FILTER_CHANGE_WINDOW:
			if(!g_hwnd_dialog) {
				g_hwnd_dialog = GetObjectDialog();
			}
			break;
		case WM_ACTIVATEAPP:
		case WM_WINDOWPOSCHANGING:
			if(fp->check[0]) {
				ClearExStyle(g_hwnd_exedit, WS_EX_TRANSPARENT);
				fp->check[0] = 0;
				fp->exfunc->filter_window_update(fp);
			}
			break;
		case WM_KEYDOWN:
		case WM_SYSKEYDOWN:
			SendMessage(GetWindow(hwnd, GW_OWNER), msg, wp, lp);
			break;
		case WM_FILTER_COMMAND:
			if(wp == 1) {
				fp->check[0] = !fp->check[0];
				func_update(fp, FILTER_UPDATE_STATUS_CHECK+0);
				fp->exfunc->filter_window_update(fp);
			}
			break;
	}

	return FALSE;
}

LPSTR track_name[] = { "sx" };
int   track_def[]  = { 180 };
int   track_min[]  = { 0 };
int   track_max[]  = { 255 };

LPSTR check_name[] = { "}EXwiɒʒm" };
int   check_def[]  = { 0 };

FILTER_DLL filter = {
	FILTER_FLAG_ALWAYS_ACTIVE,
	0, 0,
	"gҏW𔼓",
	sizeof(track_name) / sizeof(*track_name), track_name, track_def, track_min, track_max,
	sizeof(check_name) / sizeof(*check_name), check_name, check_def,
	NULL,
	func_init,
	NULL,
	func_update,
	func_WndProc,
};



extern "C" __declspec(dllexport) FILTER_DLL *GetFilterTable(void)
{
	return &filter;
}
